﻿;unused!
;{ Create ASM / obj / desc
If ListSize(ExportDLL())>0
  Enumeration
    #needed_lib
    #needed_System
    #needed_import
    #needed_end
  EndEnumeration
  
  Protected inIgnoreLabel,ignoreLine
  Protected label.s,procname.s=""
  Protected needed=#needed_lib
  Protected Tempexe.s=classinfopath+libname
  Protected firstincludeplace
  inmacro=#False
  
  CopyFile(ExecuteFile+".pb",Tempexe+".pb")
  ;-.. create ASM output
  If program(PBCompiler,#DQUOTE$+ Tempexe+".pb"+#DQUOTE$+" "+#flag_ASMEXE+" "+#DQUOTE$+classinfopath+#asmExeFile+#DQUOTE$ +CompilerFlags,GetPathPart(Tempexe) )<>0
    CreateErrorLine(LibErrorFile,"Can't create asm-output."+#LineEnd+programOutput)
    End
  EndIf
  
  ;-..Read & parse
  ClearList(CompleteFile())
  ;ClearMap(RenameProc())
  
  NewList AddInit.s()
  NewList NeededLibs.s()
  NewList NeededSystem.s()
  NewList NeededImport.s()
  NewMap PublicToExtern()
  NewList ImportExport.s()
  
  i=1
  Repeat
    label=StringField(#asmAdditionExtern,i,";")
    i+1
    If label=""
      Break
    EndIf
    AddElement(ImportExport()):ImportExport()="  "+#asm_extern+" "+label
  ForEver
  
  in=MyReadFile(#PB_Any,classinfopath+#asmfile)
  If in=0
    CreateErrorLine(LibErrorFile,"Can't read file."+#LineEnd+classinfopath+#asmExeFile)
    End    
  EndIf
  
  While Not Eof(in)
    orgline=ReadString(in)
    line=Trim(orgline)
    While FindString(line,"  ") : line=ReplaceString(line,"  "," ") : Wend
    word=LCase(StringField(line,1," "))
    
    ignoreline=#False
    
    If Right(word,1)=":" ;-.... label
      label=Left(line,FindString(line,":")-1)
      If FindString(#asmIgnoreLabels,";"+label+";",1,#PB_String_NoCase) Or FindMapElement(PublicToExtern(),label)>0
        inIgnoreLabel=#True
      Else
        inIgnoreLabel=#False
        
        
        ;Debug "label:"+label
        If procname<>""
          ;RenameProc(label)="PB_"+procname
          AddElement(ImportExport()):ImportExport()=#asm_public+" PB_"+procname
          AddElement(CompleteFile()):CompleteFile()="PB_"+procname+":"
          CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
            AddElement(ImportExport()):ImportExport()=#asm_public+" _PB_"+procname
            AddElement(ImportExport()):ImportExport()=#asm_public+" _"+procname
            AddElement(CompleteFile()):CompleteFile()="_PB_"+procname+":"
          CompilerEndIf
          
          Debug "label:"+label+" -> PB_"+procname
        EndIf
        
      EndIf
      
      
      procname=""
    EndIf
    
    Select word
      Case "pb_public";-.... pb_public
                      ;If inIgnoreLabel
        If inMacro=#False
          AddElement(ImportExport()):ImportExport()=orgline
        Else
          AddElement(CompleteFile()):CompleteFile()=orgline
        EndIf
        ;EndIf
        inIgnoreLabel=#True
        
      Case #asm_public;-.... public
        
        label=StringField(line,2," ")
        If Left(label,Len(#asm_ProcLabel))<>#asm_ProcLabel
          If FindString(#asmIgnoreLabels,";"+label+";",1,#PB_String_NoCase)
            ignoreLine=#True
            
          Else
            If FindString(#asmNotPublic,";"+label+";")>0
              ignoreLine=#True
            Else
              pos=FindString(orgline,#asm_public)
              If pos
                orgline=Left(orgline,pos-1)+#asm_extern+Mid(orgline,pos+Len(#asm_public))
                If inMacro=#False
                  AddElement(ImportExport()):ImportExport()=orgline
                  ignoreLine=#True
                EndIf
                
                PublicToExtern(label)=#True
                Debug "Ignore:"+label
              EndIf
            EndIf
          EndIf
        Else
          ignoreLine=#True
        EndIf
        
      Case #asm_Align1,#asm_Align2,#asm_Align3,#asm_Align4  ;-.... align
        inIgnoreLabel=#False          
        
      Case "call";-.... call
        If inIgnoreLabel
          label=StringField(line,2," ")
          If Left(label,Len(#asm_ProcLabel))=#asm_ProcLabel
            Debug "CALL:"+label
            AddElement(AddInit()):AddInit()=label
          EndIf
        EndIf
        
      Case "ret";-.... ret
        ignoreline=inIgnoreLabel
        inIgnoreLabel=#False
        
      Case #asm_includeplace  
        If firstincludeplace=#False
          AddElement(completeFile())
          CompleteFile()="*****************"
          firstincludeplace=#True
        EndIf
        
      Case #asm_endmacro;-.... macroend
        inIgnoreLabel=#False
        inMacro=#False
        
      Case #asm_startmacro;-.... macrostart
        inIgnoreLabel=#False
        If FindString(orgline,#asm_endmacro,0,#PB_String_NoCase)=0
          inMacro=#True
        EndIf
        
      Case ";"
        word=StringField(StringField(line,2," "),1,".")
        
        Select LCase(word)
          Case ":system";-.... :system
            needed=#needed_System
            
          Case ":import";-.... :import
            needed=#needed_import                
            
          Case "proceduredll","procedurecdll";-.... proceduredll
            procname=StringField(StringField(line,1,"("),3," ")
            If LCase(procname)=LCase(shortlibname+"init") Or LCase(procname)=LCase(shortlibname+"exit")
              procname=""
            EndIf
            
          Case "#__precompiler__init";-.... endprocedure
            ignoreLine=#True
            AddElement(CompleteFile()):CompleteFile()="; PreCompiler generated init-calls"
            ForEach AddInit()
              AddElement(CompleteFile()):CompleteFile()="  CALL "+AddInit()
            Next
            
            
          Default
            If needed < #needed_end
              name=Mid(line,3)
              If FindString(name," ")=0 And name<>"";-..... neededlibs
                Select needed
                  Case #needed_lib                      
                    If FileSize(PBHome+#path_libraries+name)>0 Or FileSize(PBHome+#path_userlibraries+name)>0
                      Debug "NEEDED LIB:"+name
                      AddElement(NeededLibs()):NeededLibs()=name
                    EndIf
                  Case #needed_import
                    AddElement(NeededImport()):NeededImport()=StringField(name,1,".")
                  Case #needed_System
                    AddElement(NeededSystem()):NeededSystem()=StringField(name,1,".")
                EndSelect
              EndIf
            EndIf
        EndSelect
        
      Default
        needed=#needed_end
        
        
    EndSelect
    
    
    
    If inIgnoreLabel=#False And ignoreLine=#False
      AddElement(CompleteFile())
      CompleteFile()=orgline
    EndIf
    
    
  Wend
  
  CloseFile(in)
  
  ;-.. Save
  out=MyCreateFile(#PB_Any,Tempexe+".asm")
  If out=0
    CreateErrorLine(LibErrorFile,"Can't create file."+#LineEnd+Tempexe+".asm")
    End    
  EndIf
  
  ForEach CompleteFile()
    If CompleteFile()<>"*****************"
      WriteStringN(out, CompleteFile() )
    Else
      ForEach ImportExport()
        WriteStringN(out,ImportExport() )
      Next
    EndIf
    
  Next
  
  CloseFile(out)
  
  ;-.. create obj
  ;#ASM_Command32="-O1 -f macho64 -s -o %output% %input%"
  Protected parameter.s
  If isX64
    parameter=#ASM_Command64
  Else
    parameter=#ASM_Command32
  EndIf
  parameter=ReplaceString(parameter,"%output%",#DQUOTE$+Tempexe+#asm_ext+#DQUOTE$)
  parameter=ReplaceString(parameter,"%input%",#DQUOTE$+Tempexe+".asm"+#DQUOTE$)
  If program(PBHome+#ASM_Compiler,parameter, GetPathPart(PBHome+#ASM_Compiler))<>0
    CreateErrorLine(LibErrorFile,"Cant obj:"+#LineEnd+programOutput)
    End
  EndIf
  
  
  
  ;-.. create desc
  Protected isString
  out=MyCreateFile(#PB_Any,Tempexe+".desc")
  If out=0
    CreateErrorLine(LibErrorFile,"Can't create file."+#LineEnd+Tempexe+".desc")
    End    
  EndIf
  
  WriteStringN(out,"; Langage used to code the library: ASM or C")
  WriteStringN(out,"ASM")
  WriteStringN(out,"; Number of windows DLL than the library need")
  WriteStringN(out, Str( ListSize(NeededSystem()) + ListSize(NeededImport())  ) )
  ForEach NeededSystem()
    WriteStringN(out, NeededSystem())
  Next
  ForEach NeededImport()
    WriteStringN(out, NeededImport())
  Next
  WriteStringN(out,"; Library type (Can be OBJ or LIB)")
  CompilerIf "."+#libname=#asm_ext
    WriteStringN(out,"LIB")
  CompilerElse
    WriteStringN(out,"OBJ")
  CompilerEndIf
  WriteStringN(out,"; Number of PureBasic library needed by the library.")
  WriteStringN(out, Str( ListSize(Neededlibs()) ) )
  ForEach NeededLibs()
    WriteStringN(out, NeededLibs())
  Next
  WriteStringN(out,"; Help directory name.")
  WriteStringN(out,shortlibname)
  WriteStringN(out,"; Library functions:")
  
  WriteStringN(out,"__"+libname+"_INIT__")
  WriteStringN(out,"InitFunction")
  WriteStringN(out,"__"+libname+"_EXIT__")
  WriteStringN(out,"EndFunction")
  
  Protected endmark.s,string.s
  Debug "EXPORTDLL - DESC"
  ForEach ExportDLL()
    With ExportDLL()
      isString=#False
      WriteString(out, \name)
      
      Debug SimplePara( \para,#True)
      count=SplitPara( SimplePara( \para,#True), paralist())
      endmark="":string=""
      For i=1 To count
        string+", "
        If Paralist(i)\optional<>""
          string+"["
        EndIf
        If Left(Paralist(i)\name,1)="*"
          If isX64
            string + "Quad"
          Else
            string + "Long"
          EndIf
        ElseIf Right(Paralist(i)\name,1)="$"
          string + "String"
          isString=#True
        ElseIf FindString(Paralist(i)\name," ")
          Select LCase(StringField(paralist(i)\name,1," "))
            Case "map"
              string+"Map"
            Case "array"
              string+"Array"
            Case "list"
              string+"LinkedList"
          EndSelect            
        Else                  
          Select LCase(Paralist(i)\type)
            Case "a","b"
              string+"Byte"
            Case "w","u","c"
              string+"Word"
            Case "l"
              string+"Long"
            Case "s"
              string+"String"
              IsString=#True
            Case "q"
              string+"Quad"
            Case "f"
              string+"Float"
            Case "d"
              string+"Double"
            Default ;"","i"
              If isX64
                string + "Quad"
              Else
                string + "Long"
              EndIf
              
          EndSelect
        EndIf
        If Paralist(i)\optional<>""
          string+"]"
        EndIf
      Next
      WriteString(out,string)
      string=", ("
      For i=1 To count
        If Paralist(i)\optional<>""
          string+"["
          endmark+"]"
        EndIf          
        If i>1
          string+", "
        EndIf
        string+ Paralist(i)\name
      Next
      string+endmark+")"
      WriteString(out,string)
      WriteStringN(out," - "+ \desc)
      
      string=""
      Select LCase(\typ)
        Case ".a",".b"
          string+"Byte"
        Case ".w",".u",".c"
          string+"Word"
        Case ".l"
          string+"Long"
        Case ".s"
          string+"String"
          isString=#True
        Case ".q"
          string+"Quad"
        Case ".f"
          string+"Float"
        Case ".d"
          string+"Double"
        Default ;"","i"
          If isX64
            string + "Quad"
          Else
            string + "Long"
          EndIf
      EndSelect
      
      If isString
        string+" | Unicode"
      EndIf            
      
      If isX64=#False
        If \isCDECL
          string+" | CDecl"
        Else
          string+" | StdCall"
        EndIf
      EndIf
      WriteStringN(out,string)
      WriteStringN(out,"")
      
    EndWith
  Next
  
  CloseFile(out)
  
  ;-.. Createlib
  ;CompilerIf #SDK_LibraryMakerSyntax=2
  parameter=#SDK_LibraryMaker_Command;="%input% /TO %outputpath%"
  parameter=ReplaceString(parameter,"%input%",#DQUOTE$+Tempexe+".desc"+#DQUOTE$)
  parameter=ReplaceString(parameter,"%inputpath%",#DQUOTE$+classinfopath+#DQUOTE$)
  parameter=ReplaceString(parameter,"%outputpath%",#DQUOTE$+PBHome+#path_userlibraries+#DQUOTE$)
  If program(PBHome+#SDK_LibraryMaker,parameter,GetPathPart(PBHome+#SDK_LibraryMaker))<>0
    CompilerIf #SDK_LibraryMakerLog<>""
      AddFileLogFile(classinfopath+#SDK_LibraryMakerLog)
    CompilerEndIf
    CreateErrorLine(LibErrorFile,"Can't create userlib."+#LineEnd+programOutput)
    End
  EndIf
  
  CompilerIf #SDK_LibraryMakerLog<>""
    AddFileLogFile(classinfopath+#SDK_LibraryMakerLog)
  CompilerEndIf
EndIf
;}
; IDE Options = PureBasic 5.61 (MacOS X - x64)
; Folding = --
; EnableXP