﻿;
;  PreCompiler 1.2
;
;changelog
; 1.2
; - Installation-Script
; - Removed DataSection/EndDataSection
; - Declares of the methodes are now in DefineClass. DefineClass should be now before all methods.

; 1.1
; - #<classname>_paratable  - Parameter list of every method - seperated by ;
; - #<classname>_nametable  - Name list of every method - seperated by ;
; - ExportResident/EndExportResident - check if anything else than structures, interfaces or constants are included
; - Create a PreProcess, when called out from the tool-menu
; - all temporary files are now stored in tmp/PBPreCompiler/
; - with extension PBlib forces creating a lib
; - exported Class in Libraries can be "extended"

#title="PreCompiler"
#Version="1.2"

EnableExplicit
;"%FILE" "%COMPILEFILE" "%EXECUTABLE"

;- os-specific

#Export_Name="_exported_"
CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_MacOS
    #dllname="dylib"
    #libname="a"
    #DS$="/"
    #flag_Debugger="--debugger"
    #flag_Unicode="--debugger"
    #flag_Thread="--thread"
    ;#flag_XP="/XP"
    #flag_Linenumbering="--linenumbering"
    #flag_Subsystem="--subsystem"
    #flag_Constant="--constant"
    #flag_PreProcess="--commented --preprocess"
    #flag_Resident="--resident"
    #flag_IgnoreResident="--ignoreresident"
    #flag_Import="--import"
    #flag_Quiet="";--quiet"
    #flag_Version="--version"
    
;     #flag_ASMEXE="--commented --executable"
    #flag_Execute="--executable"
    
    #path_compiler="compilers/"
    #path_libraries="purelibraries/"
    #path_userlibraries="purelibraries/userlibraries/"
    #path_import="purelibraries/macos/"
    #path_residents="residents/"
    
;     #asmfile="purebasic.asm"
;     #asmExeFile="purebasic.app"
    
;     #asmIgnoreLabels=";_PB_EOP;PB_ExitCode;_DLLEntryPoint@12;PureBasicStart;.SkipProcessAttach;.SkipThreadAttach;.SkipProcessDetach;.SkipThreadDetach;.End;PB_DllInit;PB_ExitCode;_PB_EOP_NoValue;_main;_PB_EndFunctions;"
;     #asmNotPublic=";_SYS_StaticStringEnd;_SYS_StaticStringStart;"
;     #asmAdditionExtern=";"
    
;     ;x64
;     #asm_Align1="pb_align"
;     #asm_Align2="pb_bssalign"
;     ;x86
;     #asm_Align3="align"
;     #asm_Align4="alignb"
    
;     #asm_ProcLabel="_Procedure"
;     
;     #asm_public="global"
;     #asm_extern="extern"
;     #asm_startmacro="%macro"
;     #asm_endmacro="%endmacro"
;     #asm_includeplace="section"
    
;     #SDK_LibraryMaker=#path_compiler+"pblibrarymaker"
;     #SDK_LibraryMaker_Command="%input% /TO %outputpath%"
;     #SDK_LibraryMakerLog=""
    
;     #ASM_Compiler=#path_compiler+"yasm"
;     #ASM_Command64="-f macho64 -s -o %output% %input%"
;     #ASM_Command32="-f macho32 -s -o %output% %input%"
;     #asm_ext=".o"
    
    
    #pb_compiler=#path_compiler+"pbcompiler"
    
    #pbSettingsPath=".purebasic/"
    #pbToolsPref="tools.prefs"
    #pbPurebasicPrefs="purebasic.prefs"
    #ExtExe=".app"
    
    #LineEnd=#CR$
    
    #userdir=0 ;use home directory
    
    
    
    
  CompilerCase #PB_OS_Windows
    #dllname="dll"
    #libname="lib"
    #DS$="\"
    #flag_Debugger="/DEBUGGER"
    #flag_Unicode="/UNICODE"
    #flag_Thread="/THREAD"
    #flag_XP="/XP"
    #flag_Linenumbering="/LINENUMBERING"
    #flag_Subsystem="/SUBSYSTEM"
    #flag_Constant="/CONSTANT"
    #flag_PreProcess="/COMMENTED /PREPROCESS"
    #flag_Resident="/RESIDENT"
    #flag_IgnoreResident="/IGNORERESIDENT"
    #flag_Import="/IMPORT"
    #flag_Quiet="/QUIET"
    #flag_Version="/VERSION"
    
;     #flag_ASMEXE="/COMMENTED /EXE"
    #flag_Execute="/EXE"
        
    #path_compiler="Compilers\"
    #path_userlibraries="PureLibraries\UserLibraries\"
    #path_libraries="PureLibraries\"
    #path_import="PureLibraries\Windows\"
    #path_residents="Residents\"
        
;     #asmfile="PureBasic.asm"
;     #asmExeFile="PureBasic.exe"
;     #asmIgnoreLabels=";_PB_EOP;PB_ExitCode;_DLLEntryPoint@12;PureBasicStart;.SkipProcessAttach;.SkipThreadAttach;.SkipProcessDetach;.SkipThreadDetach;.End;PB_DllInit;PB_ExitCode;_PB_EOP_NoValue;"
;     #asmNotPublic=";_SYS_StaticStringEnd;_SYS_StaticStringStart;"
;     #asmAdditionExtern=";"
    
;     ;x64
;     #asm_Align1="pb_align"
;     #asm_Align2="pb_bssalign"
;     ;x86
;     #asm_Align3="align"
;     #asm_Align4="alignb"
    
    
;     #asm_ProcLabel="_Procedure"
;     
;     #asm_public="public"
;     #asm_extern="extrn"
;     #asm_startmacro="macro"
;     #asm_endmacro="}"
;     #asm_ext=".obj"
;     #asm_includeplace="section"
        
;     #SDK_LibraryMaker="SDK\LibraryMaker.exe"
;     #SDK_LibraryMakerLog="PureLibrariesMaker.log"
;     #SDK_LibraryMaker_Command="%inputpath% /ALL /COMPRESSED /TO %outputpath%"
    
;     #ASM_Compiler=#path_compiler+"FAsm.exe"
;     #ASM_Command64="%input% %output%"
;     #ASM_Command32="%input% %output%"
    
    #pb_compiler=#path_compiler+"PBCompiler.exe"
    
    #pbSettingsPath="PureBasic\"
    #pbToolsPref="Tools.prefs"
    #pbPurebasicPrefs="PureBasic.prefs"
    #ExtExe=".exe"
    
    #LineEnd=#CRLF$
    
    #userdir=#PB_Directory_ProgramData
    
CompilerEndSelect
#Compiler_ErrorModule="Module not found:"; test.
#Compiler_ErrorModuleEnd="."
#Compiler_ErrorLine="Error: Line "
#Compiler_ErrorLineEnd="-"
#Compiler_ErrorStructure="The following variable doesn't have a 'Structure':"
#Compiler_ErrorStructureEnd="."
Procedure MyCreateFile(nb,file.s)
  Protected i,ret
  For i=0 To 10
    ret=CreateFile(nb,file)
    If ret
      Break
    EndIf
    Delay(100)
  Next
  ProcedureReturn ret
EndProcedure
Procedure MyReadFile(nb,file.s)
Protected i,ret
  For i=0 To 10
    ret=ReadFile(nb,file)
    If ret
      Break
    EndIf
    Delay(100)
  Next
  ProcedureReturn ret
EndProcedure
Procedure MyAppendFile(nb,file.s)
  Protected i,ret
  For i=0 To 10
    ret=OpenFile(nb,file,#PB_File_Append)
    If ret
      Break
    EndIf
    Delay(100)
  Next
  ProcedureReturn ret
EndProcedure
Procedure.s MyReadString(in)
  Protected str.s
  str=ReadString(in)
  ProcedureReturn Mid(str,FindString(str,"=")+1)
EndProcedure

Global logfileId
Procedure CreateLogFile(file.s)
  logfileId=MyCreateFile(#PB_Any,file)
EndProcedure
Procedure AddLogFile(text.s)
  If logfileId
    WriteStringN(logfileId,text)
    FlushFileBuffers(logfileId)
  EndIf
  Debug text
EndProcedure
Procedure AddFileLogFile(file.s)
  Protected in
  If logfileid
    WriteStringN(logfileId,"Include File: "+file)
    in=MyReadFile(#PB_Any,file)
    If in
      While Not Eof(in)
        WriteStringN(logfileId,"  "+ReadString(in))
      Wend
      CloseFile(in)
    EndIf
    WriteStringN(logfileId,"")
  EndIf
EndProcedure
Procedure CloseLogFile()
  If logfileId
    CloseFile(logfileid)
    logfileid=#False
  EndIf
EndProcedure


Global infoWin,infoGadget
Procedure OpenInfoWindow()
  infoWin=OpenWindow(#PB_Any,0,0,600,30,#title+" "+#version,#PB_Window_TitleBar|#PB_Window_ScreenCentered)
  If infoWin  
    infoGadget=TextGadget(#PB_Any,0,0,WindowWidth(infoWin),WindowHeight(infoWin),"",#PB_Text_Center)
  EndIf
EndProcedure
Procedure CloseInfoWindow()
  If infowin  
    CloseWindow(infoWin)
    infoWin=0
  EndIf
EndProcedure
Procedure InfoText(text.s)
  If infoWin And infoGadget
    SetGadgetText(infoGadget,text)
    AddLogFile(text)
    While WindowEvent():Wend
  EndIf
EndProcedure
Procedure InfoLoop()
  While WindowEvent():Wend
EndProcedure

Global programOutput.s
Procedure program(prg.s,para.s,work.s)
  Protected compiler
  Protected ret=-9999999
  Protected error.s,string.s
  AddLogFile("Start Programm")
  AddLogFile("  Programm:"+prg)
  AddLogFile("  Parameter:"+para)
  addlogfile("  Work:"+work)
  AddLogFile("  OutPut:")
  
  compiler=RunProgram(prg, para, work, #PB_Program_Open | #PB_Program_Read |#PB_Program_Error  |#PB_Program_Hide)
  
  If Compiler
    programOutput=""
    While ProgramRunning(Compiler)
      If AvailableProgramOutput(Compiler)
        string=ReadProgramString(Compiler)
        AddLogFile("    "+string)
        programOutput +string + #LineEnd
      EndIf  
      error=ReadProgramError(compiler)
      If error
        programOutput+"[ERROR]"+error+#LineEnd
        Debug "ERROR:"+error
        AddLogFile("    [ERROR]"+error)
      EndIf
    Wend
    Repeat
      error=ReadProgramError(compiler)
      If error
        programOutput+"[ERROR]"+error+#LineEnd
        AddLogFile("    [ERROR]"+error)
      Else
        Break
      EndIf
    ForEver
    ;programOutput+#LineEnd+";"+"Exitcode: " + Str(ProgramExitCode(Compiler))
    ret= ProgramExitCode(compiler)
    CloseProgram(Compiler)
  Else
    programOutput="Can't run "+prg+ #LineEnd+";Parameter: "+para+#LineEnd+";Work: " +work+#LineEnd    
  EndIf
  AddLogFile("")
  addlogfile( "  Exitcode:"+ret)
  Debug "----"
  
  ProcedureReturn ret
EndProcedure

;-strucs

Structure class_proc
  class.s
  proc.s
EndStructure

Structure method
  typ.s
  name.s
  para.s
  vt.s
  *VTlink.method
  NotInherited.i
  isSpecial.i
EndStructure

Structure class
  name.s
  extends.s
  defined.i
  AllowNull.i
  ErrorText.s
  List method.method()
  List struc.s()
  paralist.s
  namelist.s
  forcedLib.s
EndStructure

Structure ExportDLL
  typ.s
  name.s
  para.s
  maxopt.i
  isCDECL.i
EndStructure

Structure ExportModuleMap
  List source.s()
  doIgnore.i
EndStructure

;-maps/lists
Global NewList AddResourceFile.s()
Global NewMap class.class()

Global NewMap ExportModuleMap.ExportModuleMap()

Global NewList classlist.s()
Global NewList ExportClassList.s()

Global NewMap Class_Proc.Class_Proc()

Global NewList ExportDLL.ExportDLL()

Global NewList CompleteFile.s()

Global NewList NeededLibraries.s()

Global NewList NeededResources.s()

Global NewList ExportLibDeclare.s()

Procedure FindExportClass(name.s)
  Protected ret
  name=LCase(name)
  ForEach ExportClassList()
    If ExportClassList()=name
      ret=#True
      Break
    EndIf
  Next
  ProcedureReturn ret  
EndProcedure



Procedure.s RemoveDoubleColon(str.s)
  If Left(str,2)="::"
    ProcedureReturn Mid(str,3)
  Else
    ProcedureReturn str
  EndIf
EndProcedure
Procedure ReturnSecondCommend(text.s)
  Protected ch.s,ret,pos,instring,withESC
  pos=FindString(text,";")
  
  Repeat
    pos+1
    ch=Mid(text,pos,1)
    If ch=""
      Break
    EndIf
    If inString
     ; Debug "IN:"+ch
      Select ch
        Case "\"
          If withESC
            pos+1
          EndIf
        Case #DQUOTE$
          inString=#False
          withESC=#False
      EndSelect    
    Else
      Select ch
        Case "~"
          withESC=1
        Case #DQUOTE$
          inString=#True
        Case ";"
          ret=pos
          Break
        Default 
          withESC=#False
      EndSelect
    EndIf
  ForEver
  ProcedureReturn ret
EndProcedure
Procedure.s SimplePara(para.s,withoptional=#False,notypes=#False)
  Protected newpara.s,ch.s
  Protected inQuote,inType,ignoreRest,i
  Protected Wordstart
  
  
  
  If Left(para,1)="("
    para=Mid(para,2)
  EndIf
  If Left(para,1)=","
    para=Mid(para,2)
  EndIf
  If Right(para,1)=")"
    para=Left(Para,Len(para)-1)
  EndIf
    
  If para="" 
    ProcedureReturn ""
  EndIf
    
  #inType_none=0
  #inType_Type=1
  #inType_TypeEnd=2
  
  inType=#inType_none
  
  Wordstart=#True
  
  For i=1 To Len(para)
    If Wordstart 
      While Mid(para,i,1)=" ":i+1:Wend
      If  notypes=#True
        If LCase(Mid(para,i,4))="map "
          newpara+"Map"
          i+4
        ElseIf LCase(Mid(para,i,6))="array "
          newpara+"Array"
          i+6
        ElseIf LCase(Mid(para,i,5))="list "
          newpara+"List"
          i+5
        EndIf
      EndIf
      Wordstart=#False
    EndIf
        
    ch=Mid(para,i,1)
    
    If ch=#DQUOTE$
      inQuote!1
      If withoptional
        newpara+ch
      EndIf
      
    ElseIf inQuote
      If withoptional
        newpara+ch
      EndIf
      
      ;readover
    ElseIf ignoreRest
      
      If ch=","
        If inType=#inType_none And notypes=#False
          newpara+".i"
        EndIf
        ignoreRest=0
        inType=#inType_none
        newpara+ch
        
      ElseIf ch="=" And withoptional=#True 
        inType=#inType_TypeEnd
        ignoreRest=0
        newpara+ch
      EndIf
      
    Else
      
      Select Asc(ch)
        Case '*'
          inType=#inType_TypeEnd
          If notypes=#False
            newpara+ch
          Else
            newpara+"Pointer"
          EndIf
          
        Case '$'
          If notypes=#False
            newpara+"$"
          Else
            newpara+"String"
          EndIf
          inType=#inType_TypeEnd
          
        Case '.'
          If inType=#inType_none
            If notypes=#False
              newpara+ch
            EndIf            
            inType=#inType_Type
          Else
            inType=#inType_TypeEnd
            ignoreRest=#True;ignore structure!
          EndIf
          
        Case '('  
          If inType=#inType_none 
            If notypes=#False
              newpara+".i("
            EndIf
            inType=#inType_type
          ElseIf inType=#inType_Type
            If notypes=#False
              newpara+"("
            EndIf
          Else
            newpara+"("
          EndIf        
          
        Case '='
          If inType=#inType_none And notypes=#False
            newpara+".i"            
          EndIf
          inType=#inType_TypeEnd
          
          If withoptional=#False
            ignoreRest=#True
          Else
            newpara+ch
          EndIf
          
        Case ','
          Wordstart=#True
          If inType=#inType_none And notypes=#False
            newpara+".i"
          EndIf
          newpara+ch
          inType=#inType_none
                  
        Default
          If inType<>#inType_Type Or notypes=#False 
            newpara+ch
          EndIf
      EndSelect
    EndIf
  Next
  
  
  If inType=#inType_none And notypes=#False
    newpara+".i"
  EndIf
  ;Debug "---SimplePara **"+para+"**"+withoptional+"**"+notypes+"**"+newpara+"**"
  ProcedureReturn newpara
EndProcedure

Procedure AddMethod(ModuleName.s,classname.s,name.s,para.s,typ.s,special=#False)
  ;Debug "ADD:"+ModuleName+" "+ClassName+" "+name+" "+para+" "+typ
  Class_Proc(UCase(ModuleName+"::"+ClassName+"_"+name))
  class_proc()\class=ClassName
  class_proc()\proc=name
  
  AddElement(class()\method())
  class()\method()\name=name
  class()\method()\para=para
  class()\method()\typ=typ
  class()\method()\isSpecial=special
EndProcedure

Procedure CopyMethodList(List source.method(),List dest.method(),ClassName.s,ModuleName.s)
  ForEach source()
    If source()\isSpecial=#False
      AddElement(dest())
      dest()\typ=source()\typ
      dest()\name=source()\name
      dest()\para=source()\para
      dest()\VTlink=@source()
      
      Class_Proc(UCase(ModuleName+"::"+ClassName+"_"+source()\name))
      class_proc()\class=ClassName
      class_proc()\proc=source()\name
    EndIf
  Next
EndProcedure

Procedure FindListElement(List source.method(),name.s)
  Protected ret
  name=UCase(name)
  ForEach  source()
    If UCase(source()\name)=name
      ret=#True
      Break
    EndIf
  Next
  ProcedureReturn ret
EndProcedure

Procedure CreateErrorfile(message.s,CompilerInputFile.s,NeededLibrariesFile.s,force=#False)
  Protected ErrorFile.s
  Protected out
  out=MyCreateFile(#PB_Any,CompilerInputFile)
  If out
    If force=#False
      WriteString(out,"XIncludeFile "+#DQUOTE$+NeededLibrariesFile+#DQUOTE$+":")
      ForEach CompleteFile()
        WriteStringN(out,CompleteFile())
      Next
    EndIf
    WriteStringN(out,"CompilerError "+#DQUOTE$+ReplaceString(message,#LineEnd," / ")+#DQUOTE$) 
    CloseFile(out)
  EndIf
EndProcedure
Procedure CreateErrorLine(file.s,message.s,allowWarning=#False)
  Protected out,i,line
  Protected pos1,pos2
  
  pos1=FindString(message,#Compiler_ErrorLine,0,#PB_String_NoCase)
  pos2=FindString(message,#Compiler_ErrorLineEnd,pos1,#PB_String_NoCase)
  If pos1>0 And pos2>0
    pos1+Len(#Compiler_ErrorLine)
    line=Val( Mid(message,pos1,pos2-pos1))
  EndIf
  
  If file<>"" ;And line>0
    out=MyCreateFile(#PB_Any,file)
    If out
      For i=1 To line-1
        WriteStringN(out,"")
      Next
      If allowWarning
        WriteString(out,"CompilerIf not #PB_Compiler_Debugger:")
        WriteString(out,"CompilerWarning "+#DQUOTE$+ReplaceString(message,#LineEnd," / ")+#DQUOTE$+":")
        WriteString(out,"CompilerElse:")
      EndIf
        WriteString(out,"CompilerError "+#DQUOTE$+ReplaceString(message,#LineEnd," / ")+#DQUOTE$)
      If allowWarning
        WriteStringN(out,":CompilerEndif")
      Else
        WriteStringN(out,"")
      EndIf  
        
      CloseFile(out)
      ProcedureReturn #True
    EndIf
  EndIf
  MessageRequester(#title,message)
EndProcedure

Macro CheckCreateLibError(type)
  If DoCommand=#DoCreateLib And DoExport
    MessageRequester(#title,"You can't use "+type+" between ResidentExport And EndResidentExport."+#LineEnd+orgline)
    End
  EndIf
EndMacro
Macro IsIDECompile()
  Bool(DoCommand=#DoCreateExecute Or DoCommand=#DoCreateDLL)
EndMacro


Enumeration
  #DoCreateExecute;IDE Compile
  #DoCreateDLL;IDECompile
  #DoCreateLib
  #DoDeleteLib
  #DoPreProcess
EndEnumeration
Enumeration
  #LibInclude
  #LibStatic
EndEnumeration

Global CompilerInputFile.s
Global OriginalMainFile.s
Global PBCompiler.s
Global classinfopath.s
Global PBHome.s
Global libname.s
;Global LibType.i

#LibType=#LibInclude

Define dir ,i,*str.unicode
Global ExecuteFile.s
Global PreCompilerHome.s
Global CompilerOsBin.s
Global NeededLibrariesFile.s
Global tempfile.s
Global DoCommand.i=#DoCreateExecute
Global LibErrorFile.s
Global isX64
Global CompilerFlags.s
Global Quite=#False
;-Include

XIncludeFile "DeleteLib.pbi"
XIncludeFile "PrimaryProcess.pbi"
XIncludeFile "CreateDLL.pbi"
XIncludeFile "CreateLib.pbi"
XIncludeFile "CreatePreProcess.pbi"
XIncludeFile "InstallScript.pbi"

;-
;- Start / Parameter


OpenInfoWindow()

CompilerIf #PB_Compiler_Debugger
  PBCompiler=#PB_Compiler_Home+#pb_compiler
      
  CompilerSelect #PB_Compiler_OS
      
    CompilerCase #PB_OS_Windows
      ;OriginalMainFile="C:\Users\GPI\Documents\!PureBasic\ogretest\tutorial1.pb"
      ;OriginalMainFile="C:\Users\GPI\Documents\!PureBasic\!module\Engine3d.pbi"
      ;OriginalMainFile="C:\Users\GPI\Documents\!PureBasic\!lib\libDirectory.pbLib"
      ;ExecuteFile="C:\Users\GPI\Documents\!PureBasic\!lib\test\libindexmap.dll"
      ;OriginalMainFile="C:\Users\GPI\Documents\!PureBasic\!lib\demo.pb"
      OriginalMainFile="E:\purebasic\!Tools\PreCompiler\libClass.pbLib"
      
      ;precompilerhome="C:\Users\GPI\Documents\!PureBasic\!lib\PreCompiled\"
      precompilerhome="E:\purebasic\!Tools\PreCompiler\execute\"
      
      ;DoCommand=#DoCreateLib
      
    CompilerCase #PB_OS_MacOS
      ;OriginalMainFile="/Users/GPI/Documents/!PureBasic/!Tools/PreCompiler/libClass.pbLib"
      OriginalMainFile="/Users/GPI/Documents/!PureBasic/!Tools/PreCompiler/demos/object.pb"
      ;ExecuteFile="";/Users/GPI/Documents/!PureBasic/!lib/maclib/_libGPIx64."+#dllname
      ;PBCompiler=#PB_Compiler_Home+#path_compiler+"pbcompiler"
      PreCompilerHome="/Users/GPI/Documents/!PureBasic/!Tools/PreCompiler/macos/"
      
      
  CompilerEndSelect
  
CompilerElse

  
  ;"%OriginalMainFile" "%COMPILEFILE" "%EXECUTABLE"
  OriginalMainFile=ProgramParameter()
  CompilerInputFile=ProgramParameter()
  PBCompiler=GetEnvironmentVariable("PB_TOOL_Compiler")
  
  ExecuteFile=ProgramParameter()
  Select UCase(ProgramParameter())
    Case "CREATELIB"
      DoCommand=#DoCreateLib
    Case "DELETELIB"
      DoCommand=#DoDeleteLib
  EndSelect
  Select UCase(ProgramParameter())
    Case "QUITE"
      quite=#True
  EndSelect
  
  
  
  ; on MacOs the GetCurrentDirectory is in the .app 
  CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
    OpenPreferences("PreCompiler.ini")
    PreCompilerHome=ReadPreferenceString("WorkingDir","")
    If PreCompilerHome=""
      PreCompilerHome=PathRequester(#title+" select working directory","")
      WritePreferenceString("WorkingDir",PreCompilerHome)
      ClosePreferences()
    EndIf
  CompilerElse
    PreCompilerHome=GetCurrentDirectory()
  CompilerEndIf
CompilerEndIf  

If CountProgramParameters()=0
  InstallScript(#PB_Compiler_File)
  End
EndIf



;{ Some temporary files
classinfopath=GetTemporaryDirectory()+"PBPreCompiler"+#DS$
CreateDirectory(classinfopath)

; Clear the classinfopath
dir= ExamineDirectory(#PB_Any,classinfopath,"*.*")
If dir
  While NextDirectoryEntry(dir)
    If DirectoryEntryType(dir)=#PB_DirectoryEntry_File 
      DeleteFile( classinfopath+DirectoryEntryName(dir))
    EndIf
  Wend
  FinishDirectory(dir)
EndIf

NeededLibrariesFile=classinfopath + "LibList_.pbi"
TempFile=classinfopath + "Temp.pb"
;}

;{ Force Lib for extension pblib
Define out
If LCase(GetExtensionPart(OriginalMainFile))="pblib"
  If IsIDECompile()
    DoCommand=#DoCreateLib
    If CompilerInputFile<>""
      LibErrorFile=CompilerInputFile
      out=MyCreateFile(#PB_Any,CompilerInputFile)
      If out
        CloseFile(out)
      EndIf
      CompilerInputFile=""
    EndIf
  EndIf
EndIf
;}

;{ We need a Compiler!
If PBCompiler=""
  MessageRequester(#title,"No Compiler!")
  End
EndIf

PBHome=GetPathPart(PBCompiler)
PBHome=GetPathPart(Left(PBHome,Len(PBHome)-1))
;}

;{ Get Compiler Version
If Program(PBCompiler,#flag_Version,"")<>1
  MessageRequester(#title,"Compilererror:"+#LineEnd+programOutput)
  End
EndIf

CompilerOsBin=StringField(StringField(programOutput,2,"("),1,")")
If LCase(Trim(StringField(CompilerOsBin,2,"-")))="x64"
  isX64=#True
EndIf

*str=@CompilerOsBin
While *str\u
  If Not((*str\u>'a' And *str\u<'z') Or (*str\u>'A' And *str\u<'Z') Or (*str\u>'0' And *str\u<'9'))
    *str\u=' '
  EndIf
  *str+SizeOf(unicode)
Wend
CompilerOsBin=ReplaceString(CompilerOsBin," ","")
;}

;{ Library-Name for CreateLib/DeleteLib
If DoCommand=#DoCreateLib Or DoCommand=#DoDeleteLib
  libname=CompilerOsBin+"_"+GetFilePart(OriginalMainFile,#PB_FileSystem_NoExtension)
  ExecuteFile=PreCompilerHome+libname
  CompilerInputFile=classinfopath + "Library.pb"
  DeleteFile(CompilerInputFile)
EndIf  
;}

;{ Do we create a DLL?
If UCase(GetExtensionPart(ExecuteFile))=UCase(#dllname)
  DoCommand=#DoCreateDLL
EndIf
;}

;{ File was never saved  
If OriginalMainFile="" And CompilerInputFile<>""
  OriginalMainFile=classinfopath + "MainFile.pb"
  CopyFile(CompilerInputFile,OriginalMainFile)
EndIf
;}

;{ does a IDE-Temp-File exist? no? PreProcess
If CompilerInputFile=""
  CompilerInputFile=classinfopath + "PreProcess.pb"
  ExecuteFile=GetPathPart(OriginalMainFile)+GetFilePart(OriginalMainFile,#PB_FileSystem_NoExtension)+".PreProcess."+GetExtensionPart(OriginalMainFile)
  DeleteFile(CompilerInputFile)
  DoCommand=#DoPreProcess
EndIf
;}

;{ Check for file
If OriginalMainFile="" Or FileSize(OriginalMainFile)<=0
  Debug "Fatal end "+OriginalMainFile+" "+PBCompiler
  CreateErrorfile("file not found!",CompilerInputFile,NeededLibrariesFile,#True)
  CloseInfoWindow()
  If Not IsIDECompile()
    MessageRequester(#title,"File not found"+#LineEnd+OriginalMainFile)
  EndIf
  End
EndIf
;}

;{ Read info-files
Define name.s,dir,in,i,max,ClassName.s
dir=ExamineDirectory(#PB_Any,PreCompilerHome,CompilerOsBin+"_*.info")
If dir
  While NextDirectoryEntry(dir)
    name=DirectoryEntryName(dir)
    Debug name
    If LCase(name)<>LCase(libname+".info") And Left(name,Len(CompilerOsBin)+1)=CompilerOsBin+"_"
      in=ReadFile(#PB_Any,PreCompilerHome+DirectoryEntryName(dir))
      If in
        While Not Eof(in)
          ClassName=MyReadString(in)
          Debug "ADD CLASS: "+"::"+UCase( ClassName )
          class("::"+UCase( ClassName ))   
          class()\forcedLib=PreCompilerHome+GetFilePart(name,#PB_FileSystem_NoExtension)
          If FileSize(class()\forcedLib)>0
            class()\name=GetFilePart(name,#PB_FileSystem_NoExtension)+"::"+ClassName
          Else
            class()\name="::"+ClassName
          EndIf
          
          class()\extends= MyReadString(in)
          max=Val( MyReadString(in) )
          For i=1 To max
            AddElement( class()\method() )
            class()\method()\name=MyReadString(in)
            class()\method()\para=MyReadString(in)
            class()\method()\typ=MyReadString(in)
            class()\method()\vt=MyReadString(in)
            class()\method()\isSpecial=Val(MyReadString(in))
          Next
          max=Val( MyReadString(in) )
          For i=1 To max
            AddElement( class()\struc() )
            class()\struc()=MyReadString(in)
          Next
        Wend
        CloseFile(in)
      EndIf
      
    EndIf
  Wend
EndIf
;}

;{ Compiler Flags

If GetEnvironmentVariable("PB_TOOL_Debugger")="1"
  CompilerFlags+" "+#flag_Debugger
EndIf
If GetEnvironmentVariable("PB_TOOL_Unicode")="1"
  CompilerFlags+" "+#flag_Unicode
EndIf
If GetEnvironmentVariable("PB_TOOL_Thread")="1"
  CompilerFlags+" "+#flag_Thread
EndIf
CompilerIf #PB_Compiler_OS=#PB_OS_Windows
  If GetEnvironmentVariable("PB_TOOL_XPSkin")="1"
    CompilerFlags+" "+#flag_XP
  EndIf
CompilerEndIf
If GetEnvironmentVariable("PB_TOOL_OnError")="1"
  CompilerFlags+" "+#flag_Linenumbering
EndIf
If GetEnvironmentVariable("PB_TOOL_SubSystem")<>""
  CompilerFlags+" "+#flag_Subsystem+" "+#DQUOTE$+GetEnvironmentVariable("PB_TOOL_SubSystem")+#DQUOTE$
EndIf
CompilerFlags +" "+#flag_Quiet

If DoCommand=#DoCreateLib  
  CompilerFlags+" "+#flag_IgnoreResident+" "+#DQUOTE$+libname+".res"+#DQUOTE$
EndIf
;}


;-
;-main
;-

If DoCommand=#DoDeleteLib
  DeleteLib()
  CloseInfoWindow()
  If Quite=#False
    MessageRequester(#title,"Deinstalled Library. Please restart the IDE."+#lineend+"Don't use restart compiler, because it can destroy your code!")
  EndIf
  End
EndIf

If DoCommand=#DoCreateLib
  DeleteLib()
EndIf

PrimaryProcess()

If ListSize(ExportDLL())>0 And DoCommand=#DoCreateDLL
  CreateDll()
EndIf

If DoCommand=#DoCreateLib
  CreateLib()  
  CloseInfoWindow()
  If Quite=#False
    CreateErrorLine(LibErrorFile,"Library installed. Please restart the IDE."+#lineend+"Don't use restart compiler, because it can destroy your code!",#True)
  EndIf
  End
EndIf

If DoCommand=#DoPreProcess
  PreProcess()  
  CompilerIf #PB_Compiler_OS=#PB_OS_Windows
    RunProgram(ExecuteFile)
  CompilerEndIf
  CloseInfoWindow()
  End
EndIf

CloseInfoWindow()
; IDE Options = PureBasic 5.61 (MacOS X - x64)
; CursorPosition = 820
; FirstLine = 795
; Folding = --d-----
; EnableXP
; Executable = macos/PreCompiler.app