﻿DeclareModule Main
EndDeclareModule
Module Main
  NewMap oldmap()
  iMap.NewIndexMap=NewIndexMap()
  NewList values()
  RandomSeed(12345)
  For i=1 To 10000
    x=Random(#Integer_max)
    oldmap(Hex(x))=x
    imap\Set(x,x)
    AddElement(values())
    values()=x
  Next
  Debug MapSize(oldmap())
  Debug iMap\GetSize()
  
  ForEach values()
    If imap\Get(values())<>values()
      Debug "ERROR"
    EndIf
  Next
  
  Debug "Removetest"
  ForEach values()
    If NextElement(values())
      DeleteMapElement(oldmap(),Hex(values()))
      imap\Remove(values())
      DeleteElement(values())
    EndIf
  Next
  Debug MapSize(oldmap())
  Debug iMap\GetSize()
  ForEach values()
    If imap\Get(values())<>values()
      Debug "ERROR"
    EndIf
  Next
  
  Debug "Add new"
  For i=1 To 10000
    x=Random(#Byte_max)
    oldmap(Hex(x))=x
    imap\Set(x,x)
    AddElement(values())
    values()=x
  Next
  Debug MapSize(oldmap())
  Debug iMap\GetSize()
  
  ForEach values()
    If imap\Get(values())<>values()
      Debug "ERROR"
    EndIf
  Next
  
  imap\free()
  
  Structure doubleindex
    i1.i
    i2.i
  EndStructure
  Structure dvalues
    d.doubleindex
    value.i
  EndStructure
  
  Debug "--- doubleindex"
  FreeList(values())
  
  ClearMap(oldmap())
  imap=NewIndexMap(SizeOf(doubleindex))
  NewList dvalues.dvalues()
  
  For i=1 To 10000
    AddElement(dvalues())
    dvalues()\d\i1=Random(#Integer_max)
    dvalues()\d\i2=Random(#Integer_max)
    dvalues()\value=Random(#Integer_max)
    
    oldmap(Hex(dvalues()\d\i1)+"*"+Hex(dvalues()\d\i2))=dvalues()\value
    imap\Set( @dvalues()\d , dvalues()\value )
  Next
  Debug MapSize(oldmap())
  Debug imap\GetSize()
  
  Define *curele.doubleindex
  ForEach dvalues()
    If imap\Get( @dvalues()\d ) <> dvalues()\value
      Debug "Error"
    EndIf
    *curele=imap\GetIndex()
    If *curele\i1<>dvalues()\d\i1 Or *curele\i2<>dvalues()\d\i2
      Debug "errorIndex"
    EndIf
  Next 
  
  Debug "Removetest"
  ForEach dvalues()
    If NextElement(dvalues())
      DeleteMapElement(oldmap(),Hex(dvalues()\d\i1)+"*"+Hex(dvalues()\d\i2))
      imap\Remove(@dvalues()\d)
      DeleteElement(dvalues())
    EndIf
  Next
  Debug MapSize(oldmap())
  Debug imap\GetSize()
  
  Define *curele.doubleindex
  ForEach dvalues()
    If imap\Get( @dvalues()\d ) <> dvalues()\value
      Debug "Error"
    EndIf
    *curele=imap\GetIndex()
    If *curele\i1<>dvalues()\d\i1 Or *curele\i2<>dvalues()\d\i2
      Debug "errorIndex"
    EndIf
  Next
  
  Debug "newset"
  
  For i=1 To 10000
    AddElement(dvalues())
    dvalues()\d\i1=Random(#Byte_max)
    dvalues()\d\i2=Random(#Byte_max)
    dvalues()\value=dvalues()\d\i1 * #Word_max + dvalues()\d\i2
    
    oldmap(Hex(dvalues()\d\i1)+"*"+Hex(dvalues()\d\i2))=dvalues()\value
    imap\Set( @dvalues()\d , dvalues()\value )
  Next
  Debug MapSize(oldmap())
  Debug imap\GetSize()
  Debug ListSize(dvalues())
  
  Debug "TestDouble"
  ;Define *curele.doubleindex
  ForEach dvalues()
    If imap\Get( @dvalues()\d ) <> dvalues()\value
      Debug "Error"
    EndIf
    *curele=imap\GetIndex()
    If *curele\i1<>dvalues()\d\i1 Or *curele\i2<>dvalues()\d\i2
      Debug "errorIndex"
    EndIf
  Next 
EndModule
; IDE Options = PureBasic 5.61 (Windows - x64)
; Folding = -
; EnableXP